#!/usr/bin/perl -w

# HTML    <a href="...">...</a> κ  RSS
# Ѵ.
#
# Queries:
#	url: ش  ּ
#	filter:  href ּҸ item ȯŰ ʰ, ּҿ filter 
#		ڿ regular expression ġϴ 쿡 item ȯѴ.
#		 쿡  href ּҿ Ͽ item ȯѴ.
#	fast: href ּҰ   , ش   ϴ , ׸
#		 ð  ȮѴ.  RSS   ð ʿ 찡
#		ִ. ׷, fast=1  , ̷ Ȯ  ġ ʰ,
#		ٷ item ȯŲ.
#	ver:  RSS version
#
#	(뿹) Web2RSS Ʈ Խ Խù  RSS ȯѴ.
#	general_html.pl?url=http://kldp.net/forum/forum.php?forum_id=1541%26style=threaded&filter=message.php
#
# status: developing
# revision:
# 	2004 5 18 ó  (Ϻ Ÿ )

#use strict;
use LWP;
use URI;
use HTTP::Cookies;
use XML::RSS;
use HTML::Parser;
use CGI qw(:standard);

# Configurations from the query string
my $url;
my $rss_version;
my $filter = "";
my $fast = 0;
my $debug = 0;
my $base;
my $channel_title = "";
my $charset = "EUC-KR";

if(param())
{
	$url = param('url'); # the URL of a HTML page; NECESSARY
	$rss_version = param('ver'); # RSS version
	$filter = param('filter'); # href link filter
	$fast = param('fast'); # if on, do not check the validity of the link
	$debug = param('debug'); # debugging mode
}

# ⺻ 
$rss_version = '1.0' unless($rss_version);
my $rss = new XML::RSS;

########## Global Variables ##########
my $a_flag = 0;
my $title_flag = 0;
my $h1_flag = 0;

my $title = "";
my $link = "";
my $href = "";
my $img_src = "";
my $img_alt = "";

my $browser =  LWP::UserAgent->new(timeout=>5);


########### AUX Functions: String Converters ###########

# replace special characters
sub escape
{
	my ($str) = @_;
	
	$str =~ s/&/&amp;/g;
	$str =~ s/&amp;amp;/&amp;/g; # recover to &amp;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/&nbsp;/ /g;
	$str =~ s/\r|\n/ /g;
	$str =~ s/ +/ /g;
	$str =~ s/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F]//g;
	$str =~ s/^[ \t]+//g;
	$str =~ s/[ \t]+$//g;
	return $str;
}

# make url from anchor href
sub make_link
{
	my ($base_url, $ref) = @_;
	my $home = "";

	if($base_url =~ /(http:\/\/[^\/]+\/)/)
	{
		$home = $1;
	}

	$ref =~ s/&/&amp;/g;
	$ref =~ s/&amp;amp;/&amp;/g;
	$base_url = $home if($ref =~ /^\//);
	$base_url =~ s/\/$//g; # remove ending '/'
	$ref = "/".$ref if(not($ref =~ /^(\/|http:)/)); # add starting '/'
	$ref = $base_url.$ref if(not($ref =~ /^http:/));

	return $ref;
}


########## HTML Parsing Handlers ##########
#
sub start_handler
{
	my ($tag, $attr, $origtext) = @_;
	if($tag =~ /^a$/) # <A>
	{
		if(defined $attr->{'href'})
		{
			$href = $attr->{'href'};
			if( (not $filter) || ($href =~ /$filter/))
			{
				$img_src = "";
				$img_alt = "";
				$a_flag = 1;
			}
		}
	}
	elsif($tag =~ /^meta$/) # <META>
	{
		if( (defined $attr->{'http-eqiv'}) &&
			($attr->{'http-eqiv'}  =~ /content-type/i) )
		{
			if($attr->{'content'} =~ /charset[ \t'"\/>]*([^ \t'"\/>]+)/)
			{
				$charset = $1;
				print "Charset is $charset\n" if $debug;
			}
		}
	}
	elsif($tag =~ /^img$/) # <IMG>
	{
		if($a_flag)
		{
			$img_src = $attr->{'src'};
			$img_alt = $attr->{'alt'} if(defined $attr->{'alt'});
			print "IMG SRC: $img_src ALT: $img_alt\n" if $debug;
		}
	}
	elsif($tag =~ /^title$/) # <TITLE>
	{
		$title_flag = 1;
	}
	elsif($tag =~ /^h1$/) # <H1>
	{
		$h1_flag = 1;
	}
	else
	{
		if($a_flag)
		{
			$title .= $origtext;
		}
	}
}

sub end_handler
{
	my ($tag, $origtext) = @_;

	if(($tag =~ /^a$/) && $a_flag) # </A>
	{
		$a_flag = 0;
		$title =~ s/\n//g; #temp
		$title = escape($title);
		$title = $img_alt if(not $title);
		$title = $img_src if(not $title);
		$title = "(no title)" if(not $title);
		$link = make_link($base, $href);
		print "LINK: $link\nTITLE: $title\n" if $debug;

		# add item
		if($link)
		{
			if(( $link =~ /(\?)|(\.php$)|(\.cgi$)|(\.pl$)/) # dynamic page
				|| $fast) # do not verify the link
			{
				$rss->add_item( title=>$title, link=>$link);
			}
			else # static page
			{
				my $r = $browser->head($link);
				if($r->is_success)
				{
					my $lm = $r->headers->last_modified;
					my @date = localtime($lm);
					my $dt = sprintf "%4d-%02d-%02dT%02d:%02d+09:00",
						$date[5]+1900,$date[4]+1,$date[3],$date[2],$date[1];
					if($lm)
					{
						$rss->add_item( title=>$title, link=>$link,
								dc=>{ date => $dt, });
					}
					else
					{
						$rss->add_item( title=>$title, link=>$link);
					}
				}
 				else{ print "cannot get $link\n" if $debug; }
			}
		}

		$href = "";
		$title = "";
	} # end of </A>
	elsif(($tag =~ /^title$/) && $title_flag) # </TITLE>
	{
		$title_flag = 0;
	}
	elsif(($tag =~ /^h1$/) && $h1_flag) # </H1>
	{
		$h1_flag = 0;
	}
	else
	{
		if($a_flag)
		{
			$title .= $origtext;
		}
	}
}

sub text_handler
{
	my ($text) = @_;

	if($a_flag)
	{
		$title .= $text;
	}
	elsif($title_flag)
	{
		$channel_title = $text;
	}
	elsif($h1_flag)
	{
		$channel_title .= $text if not $channel_title;
	}
}


########## Main Routine ##########

# Initiailze HTML Parser
my $p = HTML::Parser->new(api_version => 3);
$p->handler( start => \&start_handler,"tagname, attr, text");
$p->handler( end => \&end_handler,"tagname, text");
$p->handler( text => \&text_handler,"text");

# Print out HTTP Header
my $content_type = $debug ? "Content-type: text/plain" : 
		"Content-type: application/xml";
print $content_type."\n\n";

#get web page
	my $response = $browser->get($url);
	my $ct = $response->header("Content-type");

	$response->base =~ /(.*\/)[^\/]*$/;
	$base = $1;
	print "BASE: $base\n" if $debug;


	# encoding character set from HTTP Response Header
	if($ct =~ /charset=['"]?([^'",; ]+)['"]?/i)
	{
		$charset = $1;
	}

# parse HTML and make RSS
	$p->parse($response->content);

	my @date = localtime;
	my $dstr = sprintf "%4d-%02d-%02dT%02d:%02d+09:00",
			$date[5]+1900,$date[4]+1,$date[3],$date[2],$date[1];
	$channel_title = escape($channel_title);

	$url =~ s/&/&amp;/g;
	$rss->channel(title => $channel_title,
			link => $url,
			#description=>"HTML to RSS",
			dc=>{ date => $dstr, },
			#syn=>{ updatePeriod => "hourly", updateFrequency => "6", },
	);
	
	$rss->{output} = $rss_version;
	$rss->{encoding} = $charset;
	print "Charset: $charset\n" if $debug;

	print $rss->as_string;

# THE END
